# based on https://gitlab.com/pages/mkdocs
image: python:3.11-buster

before_script:
  - pip install -r requirements.txt

# Define the order of the jobs,
# the "deploy" job only runs if the "test" is successful
stages:
  - test
  - deploy

test:
  stage: test
  script:
    # NOTE: Consider move the validation part away from here
    # and only validate e.g. when a merge request into main branch
    # is requested
    - pip install -r dev-requirements.txt
    - python scripts/validation.py
    - mkdocs build --strict --site-dir test
  artifacts:
    paths:
      - test
    # this should auto-delete all artifacts
    # however by using the according gitlab setting the artifact
    # from the latest successfull job is not deleted
    expire_in: 1 week

pages:
  stage: deploy
  script:
    - python scripts/mkdocs-nav-update.py
    - mkdocs build --strict --verbose
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
